package jpasswordrecoverytool;

import com.sun.org.apache.xalan.internal.xsltc.dom.BitArray;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import javax.swing.*;

public class AboutBox extends JDialog {

    private JLabel imageLabel;
    private JLabel authorLabel;
    private JLabel versionLabel;
    private JTextArea appDescriptionArea;
    ;
    private JLabel webpageLabel;
    private JLabel contactLabel;
    private JLabel authorDescriptionLabel;
    private JLabel versionDescriptionLabel;
    private JLabel webpageDescriptionLabel;
    private JLabel contactDescriptionLabel;
    private JPanel panel;

    public AboutBox() {
        createAndShowAboutBox();
    }

    private void createAndShowAboutBox() {
        setTitle("About");
        setSize(450, 300);
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);

        addComponentsToAboutBox(this.getContentPane());

        pack();

        setVisible(true);

    }

    private void addComponentsToAboutBox(Container contentPane) {

        readyComponents();

        panel.add(authorLabel);
        panel.add(authorDescriptionLabel);

        panel.add(versionLabel);
        panel.add(versionDescriptionLabel);
        panel.add(webpageLabel);
        panel.add(webpageDescriptionLabel);
        panel.add(contactLabel);
        panel.add(contactDescriptionLabel);

        contentPane.add(imageLabel, BorderLayout.NORTH);
        contentPane.add(appDescriptionArea, BorderLayout.CENTER);
        contentPane.add(panel, BorderLayout.SOUTH);
    }

    private void readyComponents() {
        panel = new JPanel(new GridLayout(5, 2, 10, 10));

        imageLabel = new JLabel(new ImageIcon("resources"+BruterUI.separtor+"splash.png"));

        authorLabel = new JLabel("Author:");
        versionLabel = new JLabel("Version:");
        webpageLabel = new JLabel("Webpage:");
        contactLabel = new JLabel("Contact:");
        contactDescriptionLabel = new JLabel("davidkroukamp@gmail.com");
        webpageDescriptionLabel = new JLabel("www.sourceforge.net/projects/jpassrecovery/");
        authorDescriptionLabel = new JLabel(Main.AUTHOR);
        versionDescriptionLabel = new JLabel(Main.APP_VERSION);

        appDescriptionArea = new JTextArea("This is a simple but sophisticated open source password recovery tool for M$ Windows,"+BruterUI.NEW_LINE
                + "it can effectively 'crack' any password protected archive that can be decompressed"+BruterUI.NEW_LINE
                + "by 7zip given enough time and resources. It can also bruteforce MD2, MD5, SHA-1 and SHA-2"+BruterUI.NEW_LINE
                + "(SHA-256, SHA-384, SHA-512), CRC16, CRC32, CRC64 and Adler32 hashed passwords for both Windows, and Linux."+BruterUI.NEW_LINE
                + "It requires java 7u4 and above, and 7-zip v9.20 and up for archive recovery. Keeping these above applications up"+BruterUI.NEW_LINE
                + "to date ensures peak performance.");

        appDescriptionArea.setEditable(false);

    }
}
