package jpasswordrecoverytool;

import javax.swing.JOptionPane;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author David Kroukamp
 * @version 1.08
 */
public class Main {

    public static final String APP_VERSION = "v1.09";
    public static final String APP_NAME = "JPassword Recovery Tool";
    public static final String AUTHOR = "David Kroukamp";
    private static BruterUI bruterGUI;
    public final static String NEXT_APP_VERSION = "v1.1";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {

        setLookAndFeel("Nimbus");

        Thread guiThread = createGuiThread();
        guiThread.start();

    }

    private static Thread createGuiThread() {
        Thread guiThread = new Thread(new Runnable() {

            @Override
            public void run() {
                bruterGUI = new BruterUI();
                bruterGUI.setVisible(true);
            }
        });
        return guiThread;
    }

    private static void setLookAndFeel(String lookAndFeel) {

        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if (lookAndFeel.equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            try {
                javax.swing.UIManager.setLookAndFeel("Metal");
            } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex1) {
                JOptionPane.showMessageDialog(null, "Could not set a compatible look and feel, application may not function as required!", "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }
}
